<template>
  <div class="grid pl-3">
    <div class="col-12">
      <div class="surface-card shadow-2 border-round p-4">
        <div class="flex align-items-center justify-content-between mb-3">
          <div class="text-900 font-medium text-xl">Collaboration Graph</div>
        </div>
        <CollaborationNetwork
          class="h-30rem"
          :nodes="graphNodes"
          :edges="graphEdges"
        ></CollaborationNetwork>
      </div>
    </div>
    <div class="col-12">
      <div class="surface-card shadow-2 border-round p-4">
        <div class="flex align-items-center justify-content-between mb-3">
          <div class="text-900 font-medium text-xl">MR Heat Map</div>
        </div>
        <Chart type="bar" :data="chartData" :options="chartOptions" />
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import Chart from "primevue/chart";
import type { UserName } from "../universally_shared/types";

const teamList = useCookie<UserName[] | undefined>("teamList");

const { data: team } = await useFetch(`/api/fetch/team/`, {
  query: { team: [...(teamList.value || [])] },
});

const ids = team.value?.map((member) => member.id) || [];

const { data: contributions } = await useFetch(`/api/storage/contributions`, {
  query: { ids },
});

const chartData = computed(() => {
  const chartDataTemplate = {
    datasets: [
      {
        grouped: true,
        data: [],
      },
    ],
  };

  for (const t in contributions.value?.targets) {
    const target = contributions.value?.targets[t];
    const y = target.length;
    if (y > 1) {
      const x = target[0]?.target_title;
      const chartItem = { x, y };
      chartDataTemplate.datasets[0].data.push(chartItem);
    }
  }
  return chartDataTemplate;
});

const chartOptions = computed(() => {
  return {
    plugins: {
      legend: { display: false },
    },
  };
});

const issuesContributedTo = {};
const mrContributedTo = {};

const issueDatabase = {};
const mrDatabase = {};

const addToDictionary = (dictionary: object, id: string, value: any) => {
  if (dictionary[id]) {
    dictionary[id].add(value);
  } else {
    dictionary[id] = new Set([value]);
  }
};

for (const c of contributions.value?.contributions) {
  if (c.note?.noteable_type === "Issue") {
    addToDictionary(
      issuesContributedTo,
      c.note.project_id,
      c.note.noteable_iid
    );
  } else if (c.note?.noteable_type === "MergeRequest") {
    addToDictionary(mrContributedTo, c.note.project_id, c.note.noteable_iid);
  }
}

for (const projectId in issuesContributedTo) {
  const notableIds = [...issuesContributedTo[projectId]];
  const { data: issues } = await useFetch("/api/fetch/noteable", {
    query: { projectId, notableIds, noteable: "issues" },
  });

  for (const item of issues.value) {
    issueDatabase[item.iid] = item;
  }
}

for (const projectId in mrContributedTo) {
  const notableIds = [...mrContributedTo[projectId]];
  const { data: mrs } = await useFetch("/api/fetch/noteable", {
    query: { projectId, notableIds, noteable: "merge_requests" },
  });

  for (const item of mrs.value) {
    mrDatabase[item.iid] = item;
  }
}

const graphNodes = ref([]);
const graphEdges = ref([]);
const edgeDictionary = {};
const teamIds = {};

const edgeDictionaryLabeler = ({ from, to }) => {
  return `${from}-${to}`;
};

for (const p of team.value) {
  graphNodes.value.push({ id: p.id, label: p.name });
  teamIds[p.id] = true;
}

const edgeGenerator = (c) => {
  const from = c.note?.author.id;
  let to;
  if (c?.note?.noteable_type) {
    if (c?.note?.noteable_type === "MergeRequest") {
      const item = mrDatabase[c.note?.noteable_iid];
      to = item?.author?.id;
    } else if (c?.note?.noteable_type === "Issue") {
      const item = issueDatabase[c.note?.noteable_iid];
      to = item?.author?.id;
    }
  } else if (c.target_type === "MergeRequest") {
    const item = mrDatabase[c.target_iid];
    to = item?.author?.id;
  }

  if (!teamIds[to]) {
    to = "external";
  }

  return { from, to };
};

for (const c of contributions.value?.contributions) {
  const edge = edgeGenerator(c);
  if (edge) {
    const label = edgeDictionaryLabeler(edge);
    if (edgeDictionary[label]) {
      edgeDictionary[label] += 1;
    } else {
      edgeDictionary[label] = 1;
    }
  } else {
    // console.log(c);
  }
}

for (const edge in edgeDictionary) {
  const [from, to] = edge.split("-");
  const value = edgeDictionary[edge];
  graphEdges.value.push({ from, to, value });
}

const navigateToDetailPage = (m) => {
  return navigateTo(`/team/${m.id}`);
};
</script>
